diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 71e019730..2aaed2c6b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -2,19 +2,12 @@ package net.minecraft.client.render.font;
 
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.BlendFactor;
-import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
-import net.minecraft.client.render.tessellator.RenderBuffer;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.tessellator.TessellatorBase;
-import net.minecraft.client.render.tessellator.TessellatorColor;
 import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
-import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -51,15 +44,13 @@ public class FontRendererDefault extends FontRenderer {
         this.random = new Random();
     }
 
-    protected TessellatorFont baseStringTess;
-    protected TessellatorDecorations backgroundStringTess;
+    protected TessellatorFont tessellatorFont;
     @Override
     public void init() {
-        this.baseStringTess = new TessellatorFont("FontRenderDefault Base Tessellator", 0x40000);
-        this.backgroundStringTess = new TessellatorDecorations("FontRenderDefault Deco Tessellator", 0x8000);
+        this.tessellatorFont = new TessellatorFont("FontRenderDefault Base Tessellator", 0x40000);
     }
 
-    private static final StringBuilder renderStringInternal_colorValue = new StringBuilder();
+    private final StringBuilder renderStringInternal_colorValue = new StringBuilder();
     protected void renderStringInternal(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
         double currX = x;
 
@@ -71,7 +62,7 @@ public class FontRendererDefault extends FontRenderer {
                 final char cNext = chars.charAt(i + 1);
                 if (cNext == '<') {
                     int offAmount = 1;
-                    renderStringInternal_colorValue.setLength(0);
+                    this.renderStringInternal_colorValue.setLength(0);
                     boolean ended = false;
                     for (int j = 0; j < 8; j++) { // Maximum of 8 chars allowed in argb color code
                         offAmount++;
@@ -80,12 +71,12 @@ public class FontRendererDefault extends FontRenderer {
                             ended = true;
                             break;
                         }
-                        renderStringInternal_colorValue.append(pChar);
+                        this.renderStringInternal_colorValue.append(pChar);
                     }
 
                     if (ended){
                         long colorInt = 0xFFFFFF;
-                        try { colorInt = decodeHexToLong(renderStringInternal_colorValue); } catch (final NumberFormatException ignored){}
+                        try { colorInt = decodeHexToLong(this.renderStringInternal_colorValue); } catch (final NumberFormatException ignored){}
 
                         this.currentConfig = SF.setColor(this.currentConfig, (colorInt & 0xFF_00_00_00L) == 0 ? (int) (colorInt & 0x00_FF_FF_FFL) | (SF.getColor(baseConfig) & 0xFF_00_00_00) : ((int)colorInt));
                         //noinspection AssignmentToForLoopParameter
@@ -150,18 +141,8 @@ public class FontRendererDefault extends FontRenderer {
             }
             final Font charFont = font.canRenderChar(c) ? font : this.fallbackFont;
 
-            final int tex = charFont.textureForChar(c);
-            if (this.currentTex != tex) {
-                this.currentTex = tex;
-                Shaders.FONT.bind();
-                this.baseStringTess.draw(); // Render mesh on texture change
-                GL41.glBindTexture(GL41.GL_TEXTURE_2D, tex);
-                this.baseStringTess.startDrawing();
-            }
-
-            double off = renderCharInternal(charFont, this.baseStringTess, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
-            renderCharInternalDecorations(charFont, this.backgroundStringTess, c, currX, y, z, SF.getColor(this.currentConfig), shadow);
-            currX += off;
+            this.tessellatorFont.setTexture(charFont.textureForChar(c));
+            currX += renderCharInternal(charFont, this.tessellatorFont, c, currX, y, z, shadow);
         }
 
         if (xPosBuffer != null) {
@@ -175,118 +156,29 @@ public class FontRendererDefault extends FontRenderer {
         }
     }
 
-    protected double renderCharInternal(@NotNull final Font font, @NotNull final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
-        final int rgb = color & 0xFFFFFF;
-        final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
-        final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
-
-        shadow &= !SF.isOutlined(this.currentConfig);
+    public @NotNull TessellatorFont getTessellator() {
+        return this.tessellatorFont;
+    }
 
-        final double px = 1;
-        final double px2 = px * 2;
+    public void renderStringRaw(@NotNull final Font font, final @NotNull CharSequence chars, final double x, final double y, final double z, final boolean shadow, final long baseConfig) {
+        this.currentConfig = baseConfig;
+        renderStringInternal(font, chars, x, y, z, shadow, baseConfig, null, null, null);
+    }
 
+    protected double renderCharInternal(@NotNull final Font font, @NotNull final TessellatorFont tessellator, final char c, final double x, final double y, final double z, boolean shadow) {
+        tessellator.setShadow(shadow);
+        tessellator.setConfig(this.currentConfig);
         double shift;
-        final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        final int fontIndex = FontDefault.ALLOWED_CHARACTER_INDICES[c];
         if (SF.isObfuscated(this.currentConfig) && c != ' ' && fontIndex > 0) {
             shift = font.charWidth(c);
             final char randomChar = font.getObfuscatedChar(c, this.random);
-
-            if (shadow) {
-                tessellator.setColor2i(shadowRGB, a);
-                font.renderChar(tessellator, randomChar, x + px, y + px, z, SF.isItalic(this.currentConfig));
-                if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, randomChar, x + px2, y + px, z, SF.isItalic(this.currentConfig));
-            }
-
-            if (SF.isOutlined(this.currentConfig)) {
-                tessellator.setColor2i((rgb & 0xFCFCFC) >> 2, a);
-                final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
-                for (double _x = -1; _x <= width; _x += 1/3d) {
-                    for (double _y = -1; _y <= 1.05; _y += 1/3d) {
-                        font.renderChar(tessellator, randomChar, x + _x, y + _y, z, SF.isItalic(this.currentConfig));
-                    }
-                }
-            }
-
-            tessellator.setColor2i(rgb, a);
-            font.renderChar(tessellator, randomChar, x, y, z, SF.isItalic(this.currentConfig));
-            if (SF.isBold(this.currentConfig)) {
-                font.renderChar(tessellator, randomChar, x + px, y, z, SF.isItalic(this.currentConfig));
-                shift += px;
-            }
+            font.renderChar(tessellator, randomChar, x, y, z);
 
         } else {
-            if (shadow) {
-                tessellator.setColor2i(shadowRGB, a);
-                font.renderChar(tessellator, c, x + px, y + px, z, SF.isItalic(this.currentConfig));
-                if (SF.isBold(this.currentConfig)) font.renderChar(tessellator, c, x + px2, y + px, z, SF.isItalic(this.currentConfig));
-            }
-
-            if (SF.isOutlined(this.currentConfig)) {
-                tessellator.setColor2i((rgb & 0xFCFCFC) >> 2, a);
-                final double width = SF.isBold(this.currentConfig) ? 2.05 : 1.05;
-                for (double _x = -1; _x <= width; _x += 1/3d) {
-                    for (double _y = -1; _y <= 1.05; _y += 1/3d) {
-                        font.renderChar(tessellator, c, x + _x, y + _y, z, SF.isItalic(this.currentConfig));
-                    }
-                }
-            }
-
-            tessellator.setColor2i(rgb, a);
-            shift = font.renderChar(tessellator, c, x, y, z, SF.isItalic(this.currentConfig));
-            if (SF.isBold(this.currentConfig)) {
-                font.renderChar(tessellator, c, x + px, y, z, SF.isItalic(this.currentConfig));
-                shift += px;
-            }
-        }
-        return shift;
-    }
-
-    protected void renderCharInternalDecorations(@NotNull final Font font, final @NotNull TessellatorDecorations tessellator, final char c, final double x, final double y, final double z, final int color, boolean shadow) {
-        final int rgb = color & 0xFFFFFF;
-        final int shadowRGB = (color & 0xFCFCFC) >> 2; // Divide RGB by 4
-        final int a = (color & 0xFF_00_00_00) != 0 ? (color >> 24) & 0xFF : 0xFF;
-
-        boolean strikethrough = SF.isStrikethrough(this.currentConfig);
-        boolean underline = SF.isUnderline(this.currentConfig);
-        if (!strikethrough && !underline) return;
-
-        shadow &= !SF.isOutlined(this.currentConfig);
-
-        final double px = 1;
-        final double px2 = px * 2;
-
-        final int fontHeight = font.fontHeight();
-        final double shift = SF.isBold(this.currentConfig) ? font.charWidth(c) + px : font.charWidth(c);
-
-        if (strikethrough) {
-            if (shadow) {
-                tessellator.setColor2i(shadowRGB, a);
-                tessellator.addVertex(x + px,        y + px + fontHeight / 2d,     0.0D);
-                tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d,     0.0D);
-                tessellator.addVertex(x + px + shift,y + px + fontHeight / 2d - px,0.0D);
-                tessellator.addVertex(x + px,        y + px + fontHeight / 2d - px,0.0D);
-            }
-            tessellator.setColor2i(rgb, a);
-            tessellator.addVertex(x,        y + fontHeight / 2d,     0.0D);
-            tessellator.addVertex(x + shift,y + fontHeight / 2d,     0.0D);
-            tessellator.addVertex(x + shift,y + fontHeight / 2d - px,0.0D);
-            tessellator.addVertex(x,        y + fontHeight / 2d - px,0.0D);
-        }
-
-        if (underline) {
-            if (shadow) {
-                tessellator.setColor2i(shadowRGB, a);
-                tessellator.addVertex(x,             y + px2 + fontHeight,      0.0D);
-                tessellator.addVertex(x + px + shift,y + px2 + fontHeight,      0.0D);
-                tessellator.addVertex(x + px + shift,y + px2 + fontHeight - px, 0.0D);
-                tessellator.addVertex(x,             y + px2 + fontHeight - px, 0.0D);
-            }
-            tessellator.setColor2i(rgb, a);
-            tessellator.addVertex(x - px,    y + px + fontHeight,      0.0D);
-            tessellator.addVertex(x + shift, y + px + fontHeight,      0.0D);
-            tessellator.addVertex(x + shift, y + px + fontHeight - px, 0.0D);
-            tessellator.addVertex(x - px,    y + px + fontHeight - px, 0.0D);
+            shift = font.renderChar(tessellator, c, x, y, z);
         }
+        return shift + (SF.isBold(this.currentConfig) ? 1 : 0);
     }
 
     @Override
@@ -300,17 +192,13 @@ public class FontRendererDefault extends FontRenderer {
         GLRenderer.globalSetUniforms(Shaders.FONT);
         Shaders.FONT.bind();
         GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-        GLRenderer.globalSetUniforms(Shaders.COLOR);
 
-        this.baseStringTess.startDrawing();
-        this.backgroundStringTess.startDrawingQuads();
+        this.tessellatorFont.startDrawing();
 
         renderStringInternal(font, chars, x, y, z, shadow, baseConfig, xPosBuffer, yPosBuffer, configBuffer);
 
         Shaders.FONT.bind();
-        this.baseStringTess.draw();
-        Shaders.COLOR.bind();
-        this.backgroundStringTess.draw();
+        this.tessellatorFont.draw();
 
         GLRenderer.popFrame();
     }
@@ -344,10 +232,7 @@ public class FontRendererDefault extends FontRenderer {
         GLRenderer.globalSetUniforms(Shaders.FONT);
         Shaders.FONT.bind();
         GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-        GLRenderer.globalSetUniforms(Shaders.COLOR);
-
-        this.baseStringTess.startDrawing();
-        this.backgroundStringTess.startDrawingQuads();
+        this.tessellatorFont.startDrawing();
 
         double currY = y;
         switch (alignment) {
@@ -377,9 +262,7 @@ public class FontRendererDefault extends FontRenderer {
             }
         }
         Shaders.FONT.bind();
-        this.baseStringTess.draw();
-        Shaders.COLOR.bind();
-        this.backgroundStringTess.draw();
+        this.tessellatorFont.draw();
         GLRenderer.popFrame();
 
         if (xPosBuffer != null) {
@@ -407,10 +290,8 @@ public class FontRendererDefault extends FontRenderer {
         GLRenderer.globalSetUniforms(Shaders.FONT);
         Shaders.FONT.bind();
         GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-        GLRenderer.globalSetUniforms(Shaders.COLOR);
 
-        this.baseStringTess.startDrawing();
-        this.backgroundStringTess.startDrawingQuads();
+        this.tessellatorFont.startDrawing();
 
         int currY = y;
         switch (alignment) {
@@ -440,9 +321,7 @@ public class FontRendererDefault extends FontRenderer {
             }
         }
         Shaders.FONT.bind();
-        this.baseStringTess.draw();
-        Shaders.COLOR.bind();
-        this.backgroundStringTess.draw();
+        this.tessellatorFont.draw();
         GLRenderer.popFrame();
 
         if (xPosBuffer != null) {
@@ -474,9 +353,7 @@ public class FontRendererDefault extends FontRenderer {
                 GLRenderer.globalSetUniforms(Shaders.FONT);
                 Shaders.FONT.bind();
                 GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-                GLRenderer.globalSetUniforms(Shaders.COLOR);
-                this.baseStringTess.startDrawing();
-                this.backgroundStringTess.startDrawingQuads();
+                this.tessellatorFont.startDrawing();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
                     renderStringInternal(font, line, x, currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
@@ -484,9 +361,7 @@ public class FontRendererDefault extends FontRenderer {
                     if ((currY - y) > maxHeight) break;
                 }
                 Shaders.FONT.bind();
-                this.baseStringTess.draw();
-                Shaders.COLOR.bind();
-                this.backgroundStringTess.draw();
+                this.tessellatorFont.draw();
                 GLRenderer.popFrame();
                 break;
             }
@@ -497,9 +372,7 @@ public class FontRendererDefault extends FontRenderer {
                 GLRenderer.globalSetUniforms(Shaders.FONT);
                 Shaders.FONT.bind();
                 GL41.glUniform1f(Shaders.FONT.getUniform("uZ"), (float) z);
-                GLRenderer.globalSetUniforms(Shaders.COLOR);
-                this.baseStringTess.startDrawing();
-                this.backgroundStringTess.startDrawingQuads();
+                this.tessellatorFont.startDrawing();
                 for (int i = 0; i < lines.size(); i++) {
                     final String line = lines.get(i);
                     renderStringInternal(font, line, x + (maxWidth - stringWidthDouble(line)), currY, z, shadow, baseConfig, null, null, this.localConfigBuffer);
@@ -507,9 +380,7 @@ public class FontRendererDefault extends FontRenderer {
                     if ((currY - y) > maxHeight) break;
                 }
                 Shaders.FONT.bind();
-                this.baseStringTess.draw();
-                Shaders.COLOR.bind();
-                this.backgroundStringTess.draw();
+                this.tessellatorFont.draw();
                 GLRenderer.popFrame();
                 break;
             }
@@ -540,8 +411,8 @@ public class FontRendererDefault extends FontRenderer {
         renderConstrainedDoubleImpl(font, chars, x, y, z, shadow, baseConfig, maxWidth, maxHeight, alignment, xPosBuffer, yPosBuffer, configBuffer);
     }
 
-    private static final StringBuilder splitLineIntoConstrainedLine_lineBuilder = new StringBuilder();
-    private static final StringBuilder splitLineIntoConstrainedLine_wordBuilder = new StringBuilder();
+    private final StringBuilder splitLineIntoConstrainedLine_lineBuilder = new StringBuilder();
+    private final StringBuilder splitLineIntoConstrainedLine_wordBuilder = new StringBuilder();
     protected void splitLineIntoConstrainedLine(final @NotNull Font font, final @NotNull CharSequence line, final double maxWidth, final @NotNull List<String> output) {
         final double dashWidth = font.charWidthDouble('-');
         final double spaceWidth = font.charWidthDouble(' ');
@@ -549,26 +420,26 @@ public class FontRendererDefault extends FontRenderer {
         double currLineWidth = 0;
         double currWordWidth = 0;
 
-        splitLineIntoConstrainedLine_lineBuilder.setLength(0);
-        splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+        this.splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+        this.splitLineIntoConstrainedLine_wordBuilder.setLength(0);
 
         final int length = line.length();
         for (int i = 0; i < length; i++) {
             final char c = line.charAt(i);
 
             if (c == '\n') {
-                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
-                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                this.splitLineIntoConstrainedLine_lineBuilder.append(this.splitLineIntoConstrainedLine_wordBuilder);
+                this.splitLineIntoConstrainedLine_wordBuilder.setLength(0);
                 currWordWidth = 0;
 
-                output.add(splitLineIntoConstrainedLine_lineBuilder.toString());
-                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                output.add(this.splitLineIntoConstrainedLine_lineBuilder.toString());
+                this.splitLineIntoConstrainedLine_lineBuilder.setLength(0);
                 currLineWidth = 0;
                 continue;
             }
 
             if (c == '\t') {
-                splitLineIntoConstrainedLine_wordBuilder.append("   ");
+                this.splitLineIntoConstrainedLine_wordBuilder.append("   ");
                 currWordWidth += spaceWidth * 3;
                 continue;
             }
@@ -588,14 +459,14 @@ public class FontRendererDefault extends FontRenderer {
 
                     if (ended){
                         // Add all entire rgb format symbols to word and skip index to next char after
-                        splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + offAmount + 1);
+                        this.splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + offAmount + 1);
                         //noinspection AssignmentToForLoopParameter
                         i += offAmount;
                         continue;
                     }
                 } else if (TextFormatting.FORMAT_CHARS.indexOf(cN) != -1) {
                     // Add format symbols then skip to index after
-                    splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + 2);
+                    this.splitLineIntoConstrainedLine_wordBuilder.append(line, i, i + 2);
                     //noinspection AssignmentToForLoopParameter
                     i++;
                     continue;
@@ -604,15 +475,15 @@ public class FontRendererDefault extends FontRenderer {
 
             final double charWidth = font.canRenderChar(c) ? font.charWidthDouble(c) : this.fallbackFont.charWidthDouble(c);
             if (currWordWidth + charWidth + dashWidth > maxWidth) {
-                splitLineIntoConstrainedLine_wordBuilder.append('-');
-                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
+                this.splitLineIntoConstrainedLine_wordBuilder.append('-');
+                this.splitLineIntoConstrainedLine_lineBuilder.append(this.splitLineIntoConstrainedLine_wordBuilder);
 
-                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
-                splitLineIntoConstrainedLine_wordBuilder.append(c);
+                this.splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                this.splitLineIntoConstrainedLine_wordBuilder.append(c);
                 currWordWidth = charWidth;
 
-                output.add(splitLineIntoConstrainedLine_lineBuilder.toString().trim());
-                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                output.add(this.splitLineIntoConstrainedLine_lineBuilder.toString().trim());
+                this.splitLineIntoConstrainedLine_lineBuilder.setLength(0);
                 currLineWidth = 0;
                 continue;
             }
@@ -621,29 +492,29 @@ public class FontRendererDefault extends FontRenderer {
                 /*if (c == ' ') {
                     splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
                 } else */{
-                    splitLineIntoConstrainedLine_wordBuilder.append(c);
+                    this.splitLineIntoConstrainedLine_wordBuilder.append(c);
                     currWordWidth += charWidth;
                 }
-                output.add(splitLineIntoConstrainedLine_lineBuilder.toString().trim());
-                splitLineIntoConstrainedLine_lineBuilder.setLength(0);
+                output.add(this.splitLineIntoConstrainedLine_lineBuilder.toString().trim());
+                this.splitLineIntoConstrainedLine_lineBuilder.setLength(0);
                 currLineWidth = 0;
                 continue;
             }
 
             if (c == ' ') {
-                splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder).append(' ');
+                this.splitLineIntoConstrainedLine_lineBuilder.append(this.splitLineIntoConstrainedLine_wordBuilder).append(' ');
                 currLineWidth += currWordWidth + spaceWidth;
 
-                splitLineIntoConstrainedLine_wordBuilder.setLength(0);
+                this.splitLineIntoConstrainedLine_wordBuilder.setLength(0);
                 currWordWidth = 0;
                 continue;
             }
 
-            splitLineIntoConstrainedLine_wordBuilder.append(c);
+            this.splitLineIntoConstrainedLine_wordBuilder.append(c);
             currWordWidth += charWidth;
         }
-        splitLineIntoConstrainedLine_lineBuilder.append(splitLineIntoConstrainedLine_wordBuilder);
-        final String remainder = splitLineIntoConstrainedLine_lineBuilder.toString().trim();
+        this.splitLineIntoConstrainedLine_lineBuilder.append(this.splitLineIntoConstrainedLine_wordBuilder);
+        final String remainder = this.splitLineIntoConstrainedLine_lineBuilder.toString().trim();
         if (!remainder.isEmpty()) {
             output.add(remainder);
         }
@@ -779,130 +650,4 @@ public class FontRendererDefault extends FontRenderer {
         return value;
     }
 
-    protected static class TessellatorDecorations extends TessellatorBase implements TessellatorColor {
-        private static final int VERT_SIZE = Float.BYTES * 3 + 4;
-        private boolean lockColor = false;
-
-        private int color;
-
-        private final int vao;
-        private final int vbo;
-
-        private int quadVertCount = 0;
-
-        public TessellatorDecorations(@NotNull String name, int initialCapacity) {
-            super(name, initialCapacity);
-            this.vao = GL41.glGenVertexArrays();
-            this.vbo = GL41.glGenBuffers();
-
-            GL41.glBindVertexArray(this.vao);
-            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
-
-            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
-            GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, VERT_SIZE, Float.BYTES * 3);
-            GL41.glVertexAttrib2f(2, 0f, 0f);
-            GL41.glVertexAttrib1f(3, LightIndexHelper.lightIndex2i(15, 15));
-            GL41.glVertexAttrib3f(4, 0, -1f, 0);
-
-            GL41.glEnableVertexAttribArray(0);
-            GL41.glEnableVertexAttribArray(1);
-            GL41.glBindVertexArray(0);
-        }
-
-        @Override
-        public void startDrawing(@NotNull DrawMode drawMode) {
-            super.startDrawing(drawMode);
-
-            this.lockColor = false;
-            this.quadVertCount = 0;
-            if (Tessellator.QUAD_EMULATION && drawMode == DrawMode.QUADS) {
-                this.drawMode = DrawMode.TRIANGLES;
-            }
-            setColor1i(0xFFFFFFFF);
-        }
-
-        @Override
-        public void addVertex(double x, double y, double z) {
-            checkIsDrawing();
-            checkCanFit(64);
-
-            this.data.putFloat((float) (this.offsetX + x));
-            this.data.putFloat((float) (this.offsetY + y));
-            this.data.putFloat((float) (this.offsetZ + z));
-
-            this.data.putInt(this.color);
-            this.vertexCount++;
-
-            if (Tessellator.QUAD_EMULATION && this.quadVertCount % 4 == 2) {
-                checkCanFit(128);
-                this.data.put(this.data.position(), this.data, this.data.position() - VERT_SIZE * 3, VERT_SIZE);
-                this.data.put(this.data.position() + VERT_SIZE, this.data, this.data.position() - VERT_SIZE, VERT_SIZE);
-                this.data.position(this.data.position() + VERT_SIZE * 2);
-                this.vertexCount += 2;
-            }
-
-            this.quadVertCount++;
-        }
-
-        @Override
-        public void draw() {
-            if(!this.drawing) {
-                throw new IllegalStateException(this.name + " already drawing!");
-            }
-
-            this.drawing = false;
-
-            if (this.vertexCount == 0) return;
-
-            GL41.glBindVertexArray(this.vao);
-            GL41.glVertexAttrib1f(3, GLRenderer.getLightIndex());
-
-            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
-            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
-
-            GL41.glDrawArrays(this.drawMode.cap, 0, this.vertexCount);
-            GL41.glBindVertexArray(0);
-        }
-
-        @Override
-        public @NotNull RenderBuffer record(int vao, int vbo) {
-            if(!this.drawing) {
-                throw new IllegalStateException(this.name + " already drawing!");
-            }
-
-            this.drawing = false;
-
-            GL41.glBindVertexArray(this.vao);
-            GL41.glVertexAttrib1f(3, GLRenderer.getLightIndex());
-
-            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
-            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
-
-            GL41.glDrawArrays(this.drawMode.cap, 0, this.vertexCount);
-            GL41.glBindVertexArray(0);
-
-            return new RenderBuffer(vao, vbo, 0, this.vertexCount, this.drawMode);
-        }
-
-        @Override
-        public void setColor1i(int argb) {
-            checkIsDrawing();
-            if (this.lockColor) {
-                return;
-            }
-
-            int a = (argb >> 24) & 0xFF;
-            int r = (argb >> 16) & 0xFF;
-            int g = (argb >> 8) & 0xFF;
-            int b = argb & 0xFF;
-
-            this.color = a << 24 | b << 16 | g << 8 | r;
-        }
-
-        @Override
-        public void lockColor() {
-            checkIsDrawing();
-            this.lockColor = true;
-        }
-    }
 }
